#include <stdio.h>
#include <windows.h>


#define XTEST_DLL ".\\xtest.dll"

#if ARCH == x86
#define FUNCTION_NAME_x86 "_Java_com_parasoft_xtest_common_nativecode_NativeMachineId_machineId@8"
#elif ARCH == x86_64
#define FUNCTION_NAME_x86 "_Java_com_parasoft_xtest_common_nativecode_NativeMachineId_machineId@8"
#endif

typedef int (*getMachineId)(void*, void*);

// Simple program that loads xtest.dll and calls machineId() function (defined in NativeMachineId.h)
// This will generate machineId and write it to registry for further usage.
// We can call this during Parasoft Plugin installation to ensure that machineId will be written to 
// registry during installation (because this requires administrator privileges).
//
// NOTE: machineId.exe must be in the same directory as xtest.dll to run properly
int main()
{
    HINSTANCE xtestDLL = LoadLibrary(XTEST_DLL);
    FARPROC lpfnMachineId = GetProcAddress((HMODULE)xtestDLL, FUNCTION_NAME_x86);
    int machineId = ((getMachineId)lpfnMachineId)(0, 0);

    // printf("xtest.dll addr: %p\n", xtestDLL);
    // printf("machineId addr: %p\n", lpfnMachineId);
    printf("machineId: %x\n", machineId);
    
    FreeLibrary(xtestDLL);

    return 0;
}
